## org.springframework.format.support
Class FormattingConversionServiceFactoryBean

    java.lang.Object
      org.springframework.format.support.FormattingConversionServiceFactoryBean

All Implemented Interfaces:
  FactoryBean<FormattingConversionService>, InitializingBean, EmbeddedValueResolverAware

    public class FormattingConversionServiceFactoryBean

extends Object
implements FactoryBean<FormattingConversionService>, EmbeddedValueResolverAware, InitializingBean

A factory for a `FormattingConversionService` that installs default formatters for common types such as numbers and datetimes.

Subclasses may override `installFormatters(FormatterRegistry)` to register custom formatters.

Since:
  3.0
Author:
  Keith Donald, Juergen Hoeller

Constructor Summary
`FormattingConversionServiceFactoryBean()`

Method Summary
`void` `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`FormattingConversionService` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<? extends FormattingConversionService>` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`protected void` `installFormatters(FormatterRegistry registry)` Install Formatters and Converters into the new FormattingConversionService using the FormatterRegistry SPI.
`boolean` `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` `setConverters(Set<?> converters)` Configure the set of custom converter objects that should be added.
`void` `setEmbeddedValueResolver(StringValueResolver embeddedValueResolver)` Set the StringValueResolver to use for resolving embedded definition values.
`void` `setFormatters(Set<?> formatters)` Configure the set of custom formatter objects that should be added.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FormattingConversionServiceFactoryBean

    public FormattingConversionServiceFactoryBean()

Method Detail

### setConverters

    public void setConverters(Set<?> converters)

  Configure the set of custom converter objects that should be added.

  Parameters:
    `converters` - instances of any of the following: `Converter`, `ConverterFactory`, `GenericConverter`

### setFormatters

    public void setFormatters(Set<?> formatters)

  Configure the set of custom formatter objects that should be added.

  Parameters:
    `formatters` - instances of `Formatter` or `AnnotationFormatterFactory`

### setEmbeddedValueResolver

    public void setEmbeddedValueResolver(StringValueResolver embeddedValueResolver)

  Description copied from interface: `EmbeddedValueResolverAware`
  Set the StringValueResolver to use for resolving embedded definition values.

  Specified by:
    `setEmbeddedValueResolver` in interface `EmbeddedValueResolverAware`

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### installFormatters

    protected void installFormatters(FormatterRegistry registry)

  Install Formatters and Converters into the new FormattingConversionService using the FormatterRegistry SPI. Subclasses may override to customize the set of formatters and/or converters that are installed.

### getObject

    public FormattingConversionService getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<FormattingConversionService>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class<? extends FormattingConversionService> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<FormattingConversionService>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<FormattingConversionService>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`